﻿SuperStrict
Rem
	Lanes 0-14 Spawnen enemys
	
	Waffen / Gebäude bauen zum verteidigen.
	
	ToDo:
		- Wellen-Steuerung
		- GameOver Punkt/Wellen stats ausgabe
EndRem

AppTitle = "BCC#64 - Xeres - Firewall"
Global gfx_w:Int = 512
Global gfx_h:Int = 768
Graphics(gfx_w, gfx_h, 0, 60)
AutoMidHandle(True)
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(60)

Global mx:Int, my:Int, mh1:Int, mh2:Int, ms:Float

Global Mem:Int = 48, MemRep:Int = 16
Global MemPos:Int = 0
Global MemRepSpeed:Int = 20, MemUpdatePrice:Int = 4

Global Wave:Int, WaveLen:Int = 60 * 25 '* 25 Seconds per Round
Global WaveTime:Int = WaveLen *.5

Const MaxLanes:Int = 15
Global Felder:Tscript[MaxLanes, 19]
Global Tower:TTower[MaxLanes, 3]
Global Lanes:Int[MaxLanes]
For Local i:Int = 0 Until Lanes.length
	Lanes[i] = i
Next

TEnemy.Load()
TScript.Load()
TTower.Load()

Const GS_MainGame:Int = 0, GS_SHOP:Int = 1, GS_OVER:Int = 2
Global GameState:Int = GS_MainGame
Global BuildMenu:Int, bx:Int = -1, by:Int = -1
SetBlend(ALPHABLEND)

Repeat
	Cls
	
	ms = MilliSecs()
	mx = MouseX()
	my = MouseY()
	mh1 = MouseHit(1)
	mh2 = MouseHit(2)
	
	Select GameState
		Case GS_MainGame; MainGame()
		Case GS_SHOP; Shop()
		Case GS_OVER; OScreen()
	End Select
	
	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End

Function MainGame()
	Local mh:String
	'* Kreuze
	For Local y:Int = 19 Until 23
		For Local x:Int = 0 Until 16
			SetMyColor(2)
			DrawRect(x * 32 + 15, y * 32 + 4, 2, 24)
			SetMyColor(0)
			DrawRect(x * 32 + 4, y * 32 + 14, 24, 4)
			SetMyColor(2)
			DrawRect(x * 32 + 4, y * 32 + 15, 24, 2)
		Next
	Next
	
	'* Lanes:
	For Local i:Int = 0 Until Lanes.length
		SetMyColor(3)
		DrawRect(Lanes[i] * 32 + 16, 0, 30, 15)
		SetMyColor(2)
		DrawRect(Lanes[i] * 32 + 16 + 8, 0, 14, 15)
		SetMyColor(1)
		DrawRect(Lanes[i] * 32 + 16 + 12, 0, 6, 15)
	Next
	
	'* Skripte
	For Local y:Int = 0 Until 19
		For Local x:Int = 0 Until MaxLanes
			If Felder[x, y] Then
				SetMyColor(1)
				DrawRect(x * 32 + 16, y * 32 + 16, 30, 30)
			EndIf
		Next
	Next

	If BuildMenu = 1 Then
		'SetMyColor(1)
		'DrawRect(gfx_w *.5 - 68, gfx_h * 0.1, 136, BuildMenuI.Length + 2 * 20)
		SetMyColor(4)
		DrawRect(bx * 32 + 16, by * 32 + 16, 30, 30)
		Local y:Int
		For Local S:TScript = EachIn TScript.Templates
			If Not(S.bought) Then Continue
			If Not(CanBuy(S.UseCost)) Then Continue
			If Button(S.name + "(" + S.UseCost + ")", gfx_w *.5, gfx_h * (0.5 +.03 * y)) = 1 Then
				BuildMenu = 0
				If Buy(S.UseCost) Then Felder[bx, by] = TScript.Create(S) '* Script ablegen bei genug speicher
			EndIf
			y:+1
		Next
		If Button("Back", gfx_w *.5, gfx_h * (0.5 +.03 * y)) = 1 Then BuildMenu = 0
	
	ElseIf BuildMenu = 2 Then
		SetMyColor(4)
		DrawRect(bx * 32 + 16, by * 32 + 16, 30, 30)
		Local y:Int
		For Local T:TTower = EachIn TTower.Templates
			If Not(T.bought) Then Continue
			If Not(CanBuy(T.BuyCost)) Then Continue
			If Button(T.name + "(" + T.BuyCost + ")", gfx_w *.5, gfx_h * (0.7 +.03 * y)) = 1 Then
				BuildMenu = 0 '* TTower bauen bei genug speicher
				If Buy(T.BuyCost) Then Tower[bx, by - 19] = TTower.Create(T, bx, by)
			EndIf
			y:+1
		Next
		If Button("Back", gfx_w *.5, gfx_h * (0.7 +.03 * y)) = 1 Then BuildMenu = 0

	Else
		SetMyColor(4)
		'** Feldauswahl
		If mouseInRect(16, 16, 15 * 32, 19 * 32) Then
			Local x:Int = LimitI((mx - 16) / 32, 0, 14)
			Local y:Int = LimitI((my - 16) / 32, 0, 18)
			DrawRect(x * 32 + 16, y * 32 + 16, 30, 30)
			If mh1 Then
				bx = x;by = y
				If Felder[x, y] = Null Then
					BuildMenu = 1
					Local ok:Int = 0
					For Local S:TScript = EachIn TScript.Templates
						If S.bought = True and CanBuy(S.UseCost) Then ok:+1
					Next
					If ok = 0 Then BuildMenu = 0
				EndIf
			ElseIf mh2 Then
				If Felder[x, y] <> Null Then MemRep:+Felder[x, y].UseCost; Felder[x, y] = Null
			EndIf
			If Felder[x, y] <> Null Then mh = Felder[x, y].name
		EndIf
		
		'*** Turmauswahl
		If mouseInRect(16, 19 * 32 + 16, 15 * 32, 3 * 32) Then
			Local x:Int = LimitI((mx - 16) / 32, 0, 14)
			Local y:Int = LimitI((my - 19 * 32 + 16) / 32, 0, 3) + 18
			DrawRect(x * 32 + 16, y * 32 + 16, 30, 30)
			If mh1 Then
				bx = x;by = y
				If Tower[x, y - 19] = Null Then
					BuildMenu = 2
					Local ok:Int = 0
					For Local T:TTower = EachIn TTower.Templates
						If T.bought = True And CanBuy(T.BuyCost) Then ok:+1
					Next
					If ok = 0 Then BuildMenu = 0
				EndIf
			ElseIf mh2 Then
				If Tower[x, y - 19] <> Null Then Tower[x, y - 19].Sell() ;Tower[x, y - 19] = Null
			EndIf
			If Tower[x, y - 19] <> Null mh = Tower[x, y - 19].name
		EndIf
	EndIf
	
	
	
	SetMyColor(4)
	If MemRep > 0 Then
		DrawText("Memory: " + Mem + " [+" + MemRep + "] Bytes", 8, gfx_h - 24, 0)
	Else
		DrawText("Memory: " + Mem + " Bytes", 8, gfx_h - 24, 0)
	EndIf
	If MemRep > 0 Then
		MemPos:+MemRepSpeed
		If MemPos >= 10000 Then
			Local v:Int = Int(Ceil(MemRep *.5))
			Mem:+v
			MemRep:-v
			MemPos = 0
		EndIf
	EndIf
	DrawText("Wave: " + Wave + " (" + Int(WaveTime / Float(60)) + "s)", gfx_w *.8, gfx_h - 24)
	DrawBar(8, gfx_h - 12, gfx_w - 16,, MemPos / 10000.0)
	
	If Button("online-shop", gfx_w *.5, gfx_h - 32) = 1 Then
		GameState = GS_SHOP
	EndIf
	
	If Button("next", gfx_w - 32, gfx_h - 32, 40) = 1 Then
		WaveTime = 1
	EndIf

	TTower.UpdateAll()
	TEnemy.UpdateALL()
	
	WaveTime:-1
	If WaveTime <= 0 Then
		WaveLen:-1 '** Muhaha
		WaveTime = WaveLen
		Wave:+1
		If Wave > 10 And Wave Mod 10 = 0 Then TEnemy.Speed:*1.1
		Local hp:Int = Wave * 5
		Local t:Int = Rand(0, Tenemy.Templates.Count() - 1)
		For Local i:Int = 0 Until LimitI(Wave, 1, 10)
			TEnemy.Create(T, hp, i * 4)
		Next
	EndIf

	SetMyColor(4)
	SetBlend(SOLIDBLEND)
	DrawText(mh, mx, my - 16)
	SetBlend(ALPHABLEND)
End Function

Function Shop()
	Local h:String[], hc:Int = 2
	SetScale(2, 2)
		SetMyColor(2)
		DrawText("Buy Stuff!", gfx_w *.5, gfx_h *.03)
		SetMyColor(4)
		DrawText("Scripts", 16, gfx_h *.10, 0)
		DrawText("Software", 16, gfx_h *.4, 0)
		DrawText("Garbage Collector", 16, gfx_h *.65, 0)
	SetScale(1, 1)
	SetMyColor(2)
	DrawText(Mem + " Bytes", gfx_w *.5, gfx_h *.06)
	'* Scripte
	Local i:Int
	For Local S:TScript = EachIn TScript.Templates
		Select Button(S.name, gfx_w * (.2 + (i Mod 3) * 0.3), gfx_h * (.15 + (i / 3) * 0.05))
			Case 1
				If Not(S.bought) And Buy(S.BuyCost) Then S.bought = True
			Case 2
				h = [S.BuyCost + " (" + S.UseCost + ") Bytes to buy", CutFloat(S.dmg) + " Dmg over " + CutFloat(S.duration / 1000.0, 1) + " seconds"]
				If S.spdf < 0 Then
					h:+["moves Target backwards (" + CutFloat(Abs(S.spdf), 1) + ")"]
				ElseIf S.spdf < 1 Then
					h:+["slows Target to " + Int(Abs(S.spdf) * 100.0) + "% speed"]
				EndIf
				If S.bought Then h:+["Bought already!"] ;hc = 3
		End Select
		i:+1
	Next
	
	'* Software (Tower)
	i:Int = 0
	For Local T:TTower = EachIn TTower.Templates
		Select Button(T.name, gfx_w * (.2 + (i Mod 3) * 0.3), gfx_h * (.45 + (i / 3) * 0.05))
			Case 1
				If T.bought Then
					If Buy(T.lvlb) Then
						T.lvl:+1
						T.lvlb:*2
						If T.spdf < 0 Then
							T.spdf:*1.1
						ElseIf T.spdf < 1 Then
							T.spdf:*0.9
						EndIf
					EndIf
				Else
					If Buy(T.BuyCost) Then T.bought = True
				EndIf
				
			Case 2
				If T.bought Then
					h:+[T.lvlb + " Bytes to upgrade (lvl " + T.lvl + ")"]
				Else
					h:+[T.BuyCost + " Bytes to buy"]
				EndIf
				h:+[CutFloat(T.dmg * T.lvl) + " Dmg over " + CutFloat(T.don / 1000.0, 1) + " seconds"]
				h:+["every " + CutFloat(T.doff / 1000.0, 1) + " seconds"]
				If T.spdf < 0 Then
					h:+["moves Target backwards (" + CutFloat(Abs(T.spdf), 1) + ")"]
				ElseIf T.spdf < 1 Then
					h:+["slows Target to " + Int(Abs(T.spdf) * 100.0) + "% speed"]
				EndIf
		End Select
		i:+1
	Next
	
	'* GC:	
	Select Button("Sweep speed", gfx_w *.5, gfx_h *.7)
		Case 1
			If Buy(MemUpdatePrice) Then
				MemUpdatePrice:*4
				MemRepSpeed:*1.5
			EndIf
		Case 2
			h:+[MemUpdatePrice + " Bytes to upgrade"]
			h:+[MemRepSpeed + " now"]
			h:+[Int(MemRepSpeed * 1.5) + " after upgrade"]
	End Select
	
	
	'*** Hover anzeige
	SetScale(2, 2)
	SetMyColor(hc)
	For Local i:Int = 0 Until h.Length
		DrawText(h[i], 16, gfx_h *.8 + i * 30, 0)
	Next
	SetScale(1, 1)

	If Button("Back", gfx_w *.5, gfx_h - 32) = 1 Then
		GameState = GS_MainGame
	EndIf
End Function

Function OScreen()
	SetMyColor(1)
	SetScale(2, 2)
		DrawText("GAME OVER", gfx_w *.5, gfx_h *.25)
		DrawText("Score:", gfx_w *.5, gfx_h *.75, 1) ;DrawText(TStat.Points(), gfx_w *.55, gfx_h *.75, 0)
	SetScale(1, 1)
	
	DrawText("Wave:", gfx_w *.5, gfx_h *.35, 1) ;DrawText(Wave, gfx_w *.55, gfx_h *.35, 0)
	DrawText("Bytes Used:", gfx_w *.5, gfx_h *.37, 1) ;DrawText(TStat.Mem, gfx_w *.55, gfx_h *.37, 0)
	DrawText("Defeated Malware:", gfx_w *.5, gfx_h *.39, 1) ;DrawText(TStat.Kills, gfx_w *.55, gfx_h *.39, 0)
	DrawText("Scripts Placed:", gfx_w *.5, gfx_h *.41, 1) ;DrawText(TStat.Scripts, gfx_w *.55, gfx_h *.41, 0)
	DrawText("Towers Placed:", gfx_w *.5, gfx_h *.43, 1) ;DrawText(TStat.Towers, gfx_w *.55, gfx_h *.43, 0)

	If Button("End", gfx_w *.5, gfx_h - 32) = 1 Then End
End Function

Function CanBuy:Int(_v:Int)
	If Mem >= _v Then Return True
End Function

Function Buy:Int(_v:Int)
	If Mem >= _v Then
		Mem:-_v
		TStat.Mem:+_v
		Return True
	EndIf
	Return False
End Function

Function LimitI:Int(_value:Int, _Min:Int, _Max:Int)
	If _value < _Min Then
		Return _Min
	ElseIf _value > _Max Then
		Return _max
	Else
		Return _value
	EndIf
End Function

Function CutFloat:String(zahl:Float, stellen:Int = 2)
	stellen = LimitI(stellen, 1, 6)
	Local s:String = String(zahl)
	Local pos:Int = s.Find(".")
	Return (s[..pos + 1 + stellen])
End Function

Function SetMyColor(_v:Int = 0)
	Select _v
		Case 0;SetColor(0, 0, 0)
		Case 1;SetColor(255, 0, 0)
		Case 2;SetColor(0, 255, 0)
		Case 3;SetColor(0, 0, 255)
		Case 4;SetColor(255, 255, 255)
		Default; SetMyColor(Rand(0, 4))
	EndSelect
End Function

Function DrawKreis(x:Float, y:Float, r:Float)
	DrawOval(x - r *.5, y - r *.5, r, r)
End Function

Function mouseInRect:Int(x:Int, y:Int, w:Int, h:Int)
	If mx <= x Then Return False
	If my <= y Then Return False
	If mx >= x + w Then Return False
	If my >= y + h Then Return False
	Return True	
End Function

Function Button:Int(_txt:String, _x:Int, _y:Int, _w:Int = 128, _h:Int = 16)
	_x:-_w *.5
	If mouseInRect(_x, _y, _w, _h)
		SetMyColor(2)
		DrawRect(_x, _y, _w, _h)
		SetMyColor(0)
		DrawText(_txt, _x + _w *.5, _y + _h *.5)
		If mh1 Then Return True
		Return 2
	Else
		SetMyColor(3)
		DrawRect(_x, _y, _w, _h)
		SetMyColor(1)
		DrawText(_txt, _x + _w *.5, _y + _h *.5)
	EndIf
End Function

Function DrawBar(x:Int, y:Int, w:Int, h:Int = 8, p:Float = 1)
	SetMyColor(4)
	DrawRect(x, y, w, h)
	SetMyColor(0)
	DrawRect(x + 1, y + 1, w - 2, h - 2)
	SetMyColor(2)
	DrawRect(x + 2, y + 2, (w - 4) * p, h - 4)
End Function
   
Function DrawText(_txt:String, _x:Float, _y:Float, _HX:Float = 0.5, _HY:Float = 0.5)
	Local scale_X:Float, scale_Y:Float
	GetScale(scale_X, scale_Y)
	brl.max2d.DrawText(_txt, Int(_x - (Float(TextWidth(_txt)) * scale_X * _HX)), Int(_y - (Float(TextHeight(_txt)) * scale_Y * _HY)))
End Function

Type TEnemy
	Field x:Float, y:Float
	Field c:Int, s:String '* Farbe, Symbol
	Field spd:Float '* Geschwindigkeit
	Field l:Int '* Lane
	Field hp:Float, maxhp:Float
	Field Ef:TScript, towers:TList
	
	Const Size:Float = 16
	Global Speed:Float = 0.6
	
	Global List:TList[MaxLanes]
	Global Templates:TList = New TList
	
	Function Load()
		For Local i:Int = 0 Until MaxLanes
			TEnemy.List[i] = New TList
		Next
		Local source:TStream = ReadFile("Data/Enemys.txt")
		While source.Eof() = False
			TEnemy.CreateTemp(source.ReadLine().Split(";"))
		Wend
		source.Close()
	End Function
	
	Function CreateTemp(_para:String[])
		Local E:TEnemy = New TEnemy
		E.s = _para[0]
		E.c = _para[1].ToInt()
		E.spd = _para[2].ToFloat()
		E.hp = _para[3].ToFloat()
		Templates.AddLast(E)
	End Function
	
	Method Del()
		If Ef Then MemRep:+Ef.UseCost
		Self.towers.Clear()
		List[Self.l].Remove(Self)
	End Method
	
	Method Draw()
		SetMyColor(c)
		If Ef Or towers.Count() Then SetMyColor(-1)
		
		DrawKreis(x, y, TEnemy.Size)
		SetMyColor(0)
		DrawText(s, x, y + 1)
		
		DrawBar(x - 10, y - 18, 20,, Float(hp) / Float(maxhp))
		
		'SetMyColor(4)
		'DrawText("hp:" + hp, x, y + 30)
	End Method
	
	Method GetSpd:Float()
		Local f:Float = 1.0, neg:Int = 0
		For Local t:TTower = EachIn towers
			If Sgn(t.spdf) = -1 Then neg = 1
			f:*Abs(t.spdf)
		Next
		If Ef Then
			If Sgn(Ef.spdf) = -1 Then neg = 1
			f:*Abs(Ef.spdf)
		EndIf
		If neg Then f:*- 1
		Return (TEnemy.Speed * spd * f)
	End Method
	
	Method DoEf:Int()
		For Local t:TTower = EachIn towers
			hp:-Float(t.dmg) / Float(t.don)
		Next
		towers.Clear()
	
		If Ef Then
			hp:-Float(Ef.dmg) / Float(Ef.duration)
			Ef.lifetime:-1
			If Ef.lifetime <= 0 Then MemRep:+Ef.UseCost ;Ef = Null
		EndIf
		
		If hp < 0.001 Then Self.Del() ;MemRep:+Rand(2, Rand(4, 8)) ;TStat.Kills:+1 ; Return True
	End Method
	
	Function Create(_typ:Int = -1, _hp:Int = 10, _back:Int)
		Local i:Int = 0, E:TEnemy
		If _typ = -1 Then _typ = Rand(0, TEnemy.Templates.Count() - 1)
		For Local Z:TEnemy = EachIn TEnemy.Templates
			If i = _typ Then
				E = New TEnemy
				E.s = Z.s
				E.c = Z.c
				E.spd = Z.spd
				E.hp = Z.hp
				E.towers = New TList
				Exit
			EndIf
			i:+1
		Next 
		If E = Null Then RuntimeError("No such Enemy-type!")
	
		'** Lane-wahl:
		E.l = Lanes[Rand(0, Lanes.length - 1)]
		TEnemy.List[E.l].AddLast(E)
		E.x = (E.l + 1) * 32
		E.y = -TEnemy.Size * _back
		E.hp:*_hp
		E.maxhp = E.hp
	End Function
	
	Function UpdateALL()
		For Local l:Int = 0 Until MaxLanes
			For Local B:TEnemy = EachIn TEnemy.List[l]
				B.y:+B.GetSpd()
				B.Draw()
				
				If B.DoEf() Then Continue
				
				'*** Feld mit Script:
				Local x:Int = LimitI((B.x - 16) / 32, 0, 14)
				Local y:Int = LimitI((B.y - 16) / 32, 0, 18)
				If Felder[x, y] And Not(B.Ef) Then
					B.Ef = Felder[x, y]
					B.Ef.Start()
					Felder[x, y] = Null
				EndIf
								
				'*** Durchgekommen:
				If B.y > gfx_h *.81 Then
					For Local e2:TEnemy = EachIn TEnemy.List[B.l]
						e2.Del()
					Next
					Local IndexDel:Int
					For Local i:Int = 0 Until Lanes.length
						If Lanes[i] = B.l Then IndexDel = i ; Exit
					Next
					Lanes = Lanes[..IndexDel] + Lanes[IndexDel + 1..Lanes.length]
					B.Del()
					
					If Lanes.length = 0 Then GameState = GS_OVER ; Return
				EndIf
			Next
		Next
	End Function
	
End Type

Type TScript
	Field name:String
	Field BuyCost:Int, UseCost:Int
	Field dmg:Float, duration:Int, lifetime:Int
	Field spdf:Float, bought:Int
	
	Global Templates:TList = New TList

	Function Load()
		Local source:TStream = ReadFile("Data/Scripts.txt")
		While source.Eof() = False
			TScript.CreateTemp(source.ReadLine().Split(";"))
		Wend
		source.Close()
	End Function
	
	Function CreateTemp(_para:String[])
		Local S:TScript = New TScript
		S.name = _para[0]
		S.BuyCost = _para[1].ToInt()
		S.UseCost = _para[2].ToInt()
		S.dmg = _para[3].ToFloat()
		S.duration = _para[4].ToInt()
		S.spdf = _para[5].ToFloat()
		Templates.AddLast(S)
	End Function
	
	Function Create:TScript(_:TScript)
		Local Z:TScript = New TScript
		Z.name = _.name
		Z.dmg = _.dmg
		Z.duration = _.duration
		Z.UseCost = _.UseCost
		Z.spdf = _.spdf
		TStat.Scripts:+1
		Return Z
	End Function
	
	Method Start()
		duration = (duration * 60 / 1000)
		lifetime = duration
	End Method

End Type

Type TTower

	Field name:String, BuyCost:Int
	Field don:Int, doff:Int, onoff:Int, lifetime:Int
	Field dmg:Float, spdf:Float, l:Int, y:Int
	Field lvl:Int, lvlb:Int, bought:Int
	
	Global Templates:TList = New TList
	Global List:TList = New TList
	
	Function Load()
		Local source:TStream = ReadFile("Data/Towers.txt")
		While source.Eof() = False
			TTower.CreateTemp(source.ReadLine().Split(";"))
		Wend
		source.Close()
	End Function
	
	Function CreateTemp(_para:String[])
		Local T:TTower = New TTower
		T.name = _para[0]
		T.BuyCost = _para[1].ToInt()
		T.lvlb = _para[2].ToInt()
		T.don = _para[3].ToInt()
		T.doff = _para[4].ToFloat()
		T.dmg = _para[5].ToInt()
		T.spdf = _para[6].ToFloat()
		T.lvl = 1
		Templates.AddLast(T)
	End Function
	
	Function Create:TTower(_:TTower, _lane:Int, _y:Int)
		Local T:TTower = New TTower
		T.name = _.name
		T.BuyCost = _.BuyCost
		T.lvlb = _.lvlb
		T.don = _.don
		T.doff = _.doff
		T.dmg = _.dmg
		T.spdf = _.spdf
		T.l = _lane
		T.y = _y
		T.lvl = _.lvl
		T.Start()
		TTower.List.AddLast(T)
		TStat.Towers:+1
		Return T
	End Function
	
	Method Start()
		don = (don * 60 / 1000)
		doff = (doff * 60 / 1000)
		lifetime = Rand(doff / 2, doff)
		onoff = False
	End Method
	
	Function UpdateAll()
		For Local t:TTower = EachIn TTower.List
			
			t.lifetime:-1
			If t.onoff Then
				SetMyColor(1)
				DrawRect((t.l + 1) * 32 - 2, (t.y + 1) * 32, 4, -gfx_h)
				SetMyColor(2)
				For Local e:TEnemy = EachIn TEnemy.List[t.l]
					e.towers.AddLast(t)
				Next
				If t.lifetime <= 0 Then t.onoff = 0 ; t.lifetime = t.doff
			Else
				SetMyColor(3)
				If t.lifetime <= 0 Then t.onoff = True ; t.lifetime = t.don
			EndIf

			DrawRect(t.l * 32 + 16, t.y * 32 + 16, 30, 30)
			
			SetMyColor(4)
			DrawText(t.lvl, (t.l + 1) * 32, (t.y + 1) * 32)
			
		Next
	End Function
	
	Method Sell()
		MemRep:+Self.BuyCost
		TTower.List.Remove(Self)
	End Method

End Type

Type TStat
	Global Mem:Int, Kills:Int, Towers:Int, Scripts:Int
	Function Points:Long()
		Return Long(Wave) * Mem * Kills * Towers * Scripts * 0.001
	End Function
End Type
